import { FunctionInvocationFilePaths } from "../types/FunctionInvocationFilePaths";
import { PluginEstimationResult, Transformation, TransformationDefinitionStep } from "..";
import { PluginReference } from "../types/PluginReference";
import { FileDownloader } from "../types/transform/FileDownloader";
export interface TransformationStepBase<TParams> {
    download: FileDownloader;
    paths: FunctionInvocationFilePaths;
    step: TransformationDefinitionStep<TParams>;
    transformation: Transformation;
}
export interface TransformationStep<TParams, TEstimation extends PluginEstimationResult> extends TransformationStepBase<TParams> {
    estimationResult: TEstimation;
    previousAsyncSteps: Array<Promise<void>>;
    type: "TransformationStep";
}
export interface TransformationStepEstimation<TParams> extends TransformationStepBase<TParams> {
    type: "TransformationStepEstimation";
}
export interface PluginHealthCheck {
    plugin: PluginReference;
    type: "PluginHealthCheck";
}
export declare type PluginInvocation<TParams, TEstimation extends PluginEstimationResult> = TransformationStep<TParams, TEstimation> | TransformationStepEstimation<TParams> | PluginHealthCheck;
