import { FunctionInvocationFilePaths } from "upload-plugin-sdk/types/FunctionInvocationFilePaths";
import { PluginEstimationResult, Transformation, TransformationDefinitionStep } from "upload-plugin-sdk";
import { PluginReference } from "upload-plugin-sdk/types/PluginReference";
import { FileDownloader } from "upload-plugin-sdk/types/transform/FileDownloader";

export interface TransformationStepBase<TParams> {
  download: FileDownloader;
  paths: FunctionInvocationFilePaths;
  step: TransformationDefinitionStep<TParams>;
  transformation: Transformation;
}

export interface TransformationStep<TParams, TEstimation extends PluginEstimationResult>
  extends TransformationStepBase<TParams> {
  estimationResult: TEstimation;
  previousAsyncSteps: Array<Promise<void>>;
  type: "TransformationStep";
}

export interface TransformationStepEstimation<TParams> extends TransformationStepBase<TParams> {
  type: "TransformationStepEstimation";
}

export interface PluginHealthCheck {
  plugin: PluginReference;
  type: "PluginHealthCheck";
}

export type PluginInvocation<TParams, TEstimation extends PluginEstimationResult> =
  | TransformationStep<TParams, TEstimation>
  | TransformationStepEstimation<TParams>
  | PluginHealthCheck;
